Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.jstacs.scoringFunctions
Class IndependentProductScoringFunction

    java.lang.Object
      de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
          de.jstacs.scoringFunctions.IndependentProductScoringFunction

All Implemented Interfaces:
  NormalizableScoringFunction, ScoringFunction, Storable, Cloneable

    public class IndependentProductScoringFunction

extends AbstractNormalizableScoringFunction

This class enables the user to model parts of the sequence independent of each other. The first part of the sequence is modeled by the first NormalizableScoringFunction and has the length of the first NormalizableScoringFunction, the second part starts directly after the first part, is modeled by the second ... .

Author:
  Jens Keilwagen

Field Summary

Fields inherited from class de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
`alphabets, length, r`

Fields inherited from interface de.jstacs.scoringFunctions.ScoringFunction
`UNKNOWN`

Constructor Summary
`IndependentProductScoringFunction(NormalizableScoringFunction... functions)` This constructor creates an instance of a given series of independent NormalizableScoringFunctions.
`IndependentProductScoringFunction(NormalizableScoringFunction[] functions, int[] length)` This constructor creates an instance of a given series of independent NormalizableScoringFunctions and lengths.
`IndependentProductScoringFunction(StringBuffer source)` This is the constructor for `Storable`.

Method Summary
`void` | `addGradientOfLogPriorTerm(double[] grad, int start)` This method computes the gradient of `getLogPriorTerm()` for each parameter of this model.
`IndependentProductScoringFunction` | `clone()` Creates a clone (deep copy) of the current `ScoringFunction` instance.
`protected void` | `fromXML(StringBuffer rep)` This method is called in the constructor to create a scoring function from a StringBuffer
`double[]` | `getCurrentParameterValues()` Returns a double array of dimension `getNumberOfParameters()` containing the current parameter values.
`double` | `getEss()` Returns the equivalent sample size of this model, i.e. the equivalent sample size for the class or component that is represented by this model.
`String` | `getInstanceName()` Returns a short instance name.
`double` | `getLogPriorTerm()` This method computes a value that is proportional to `getESS()*Math.log( getNormalizationConstant() ) + Math.log( prior ).`
`double` | `getLogScore(Sequence seq, int start)` Returns the log score for the sequence
`double` | `getLogScoreAndPartialDerivation(Sequence seq, int start, IntList indices, DoubleList partialDer)` Returns the log score for the sequence and fills the list with the indices and the partial derivations.
`double` | `getNormalizationConstant()` Returns the sum of the scores over all sequences of the event space.
`int` | `getNumberOfParameters()` The number of parameters in this scoring function.
`int` | `getNumberOfRecommendedStarts()` This method return the number of recommended optimization starts.
`double` | `getPartialNormalizationConstant(int parameterIndex)` Returns the partial normalization constant for the parameter with index `parameterIndex`.
`int` | `getSizeOfEventSpaceForRandomVariablesOfParameter(int index)` Returns the size of the event space of the random variables that are affected by parameter no.
`void` | `initializeFunction(int index, boolean freeParams, Sample[] data, double[][] weights)` This method creates the underlying structure of the scoring function.
`void` | `initializeFunctionRandomly(boolean freeParams)` This method initializes the scoring function randomly.
`boolean` | `isInitialized()` This method can be used to determine whether the model is initialized.
`void` | `setParameters(double[] params, int start)` This method sets the internal parameters to the values of `params` between `start` and `start + this.getNumberOfParameters() - 1`
`String` | `toString()`
`StringBuffer` | `toXML()` This method returns an XML-representation of an instance of the implementing class.

Methods inherited from class de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
`getAlphabetContainer, getInitialClassParam, getLength, getLogScore, getLogScoreAndPartialDerivation, isNormalized, isNormalized`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### IndependentProductScoringFunction

    public IndependentProductScoringFunction(NormalizableScoringFunction... functions)
                                      throws CloneNotSupportedException,
                                             IllegalArgumentException

  This constructor creates an instance of a given series of independent NormalizableScoringFunctions. The length that is modeled by each component is determined by `ScoringFunction.getLength()`. So the length should not be 0.

  Parameters:
    `functions` - the components
  Throws:
    `CloneNotSupportedException` - if at least one component could not be cloned
    `IllegalArgumentException` - if at least one component has length 0 or the components do not have the same ess
  See Also:
    `IndependentProductScoringFunction(NormalizableScoringFunction[], int[])`

### IndependentProductScoringFunction

    public IndependentProductScoringFunction(NormalizableScoringFunction[] functions,
                                             int[] length)
                                      throws CloneNotSupportedException

  This constructor creates an instance of a given series of independent NormalizableScoringFunctions and lengths.

  Parameters:
    `functions` - the components
    `length` - the length of each component
  Throws:
    `CloneNotSupportedException` - if at least one component could not be cloned
    `IllegalArgumentException` - if the lengths and the components are not matching or the components do not have the same ess
  See Also:
    `IndependentProductScoringFunction(NormalizableScoringFunction[], int[])`

### IndependentProductScoringFunction

    public IndependentProductScoringFunction(StringBuffer source)
                                      throws NonParsableException

  This is the constructor for `Storable`.

  Parameters:
    `source` - the xml representation
  Throws:
    `NonParsableException` - if the representation could not be parsed.

Method Detail

### clone

    public IndependentProductScoringFunction clone()
                                            throws CloneNotSupportedException

  Description copied from interface: `ScoringFunction`
  Creates a clone (deep copy) of the current `ScoringFunction` instance.

  Specified by:
    `clone` in interface `ScoringFunction`
  Overrides:
    `clone` in class `AbstractNormalizableScoringFunction`
  Returns:
    the cloned instance
  Throws:
    `CloneNotSupportedException`

### getSizeOfEventSpaceForRandomVariablesOfParameter

    public int getSizeOfEventSpaceForRandomVariablesOfParameter(int index)

  Description copied from interface: `NormalizableScoringFunction`
  Returns the size of the event space of the random variables that are affected by parameter no. `index`, i.e. the product of the sizes of the alphabets at the position of each random variable affected by parameter `index`. For DNA-alphabets this corresponds to 4 for a PWM, 16 for a WAM except position 0, ...

  Parameters:
    `index` - the index of the parameter
  Returns:
    the size of the event space

### getNormalizationConstant

    public double getNormalizationConstant()

  Description copied from interface: `NormalizableScoringFunction`
  Returns the sum of the scores over all sequences of the event space.

  Returns:
    the normalization constant Z

### getPartialNormalizationConstant

    public double getPartialNormalizationConstant(int parameterIndex)
                                           throws Exception

  Description copied from interface: `NormalizableScoringFunction`
  Returns the partial normalization constant for the parameter with index `parameterIndex`. This is the partial derivation of the normalization constant for the parameter with index `parameterIndex` `\frac{\partial Z(\lambda)}{\partial \lambda_{index}}`.

  Parameters:
    `parameterIndex` - the index of the parameter
  Returns:
    the partial normalization constant
  Throws:
    `Exception` - if something went wrong with the Normalization

### getEss

    public double getEss()

  Description copied from interface: `NormalizableScoringFunction`
  Returns the equivalent sample size of this model, i.e. the equivalent sample size for the class or component that is represented by this model.

  Returns:
    the equivalent sample size.

### initializeFunction

    public void initializeFunction(int index,
                                   boolean freeParams,
                                   Sample[] data,
                                   double[][] weights)
                            throws Exception

  Description copied from interface: `ScoringFunction`
  This method creates the underlying structure of the scoring function.

  Parameters:
    `index` - the index of the class the scoring function models
    `freeParams` - if `true`, the (reduced) parameterization is used``
    `data` - the samples
    `weights` - the weights of the sequences in the samples
  Throws:
    `Exception`

### fromXML

    protected void fromXML(StringBuffer rep)
                    throws NonParsableException

  Description copied from class: `AbstractNormalizableScoringFunction`
  This method is called in the constructor to create a scoring function from a StringBuffer

  Specified by:
    `fromXML` in class `AbstractNormalizableScoringFunction`
  Parameters:
    `rep` - the XML representation
  Throws:
    `NonParsableException` - if the StringBuffer could not be parsed.

### getInstanceName

    public String getInstanceName()

  Description copied from interface: `ScoringFunction`
  Returns a short instance name.

  Returns:
    a short instance name

### getCurrentParameterValues

    public double[] getCurrentParameterValues()
                                       throws Exception

  Description copied from interface: `ScoringFunction`
  Returns a double array of dimension `getNumberOfParameters()` containing the current parameter values. If on e likes to use these parameters to start an optimization it is highly recommended to invoke `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])` before. After an optimization this method can be used to get the current parameter values.

  Returns:
    the current parameter values
  Throws:
    `Exception` - is thrown if no parameters exist, yet

### getLogScore

    public double getLogScore(Sequence seq,
                              int start)

  Description copied from interface: `ScoringFunction`
  Returns the log score for the sequence

  Parameters:
    `seq` - the sequence
    `start` - the startposition in the sequence
  Returns:
    the log score for the sequence

### getLogScoreAndPartialDerivation

    public double getLogScoreAndPartialDerivation(Sequence seq,
                                                  int start,
                                                  IntList indices,
                                                  DoubleList partialDer)

  Description copied from interface: `ScoringFunction`
  Returns the log score for the sequence and fills the list with the indices and the partial derivations.

  Parameters:
    `seq` - the sequence
    `start` - the startposition in the sequence
    `indices` - after method invocation the list should contain the indices i where \frac{\partial \log score(seq)}{\partial \lambda_i} is not zero
    `partialDer` - after method invocation the list should contain the corresponding \frac{\partial \log score(seq)}{\partial \lambda_i}
  Returns:
    the log score

### getNumberOfParameters

    public int getNumberOfParameters()

  Description copied from interface: `ScoringFunction`
  The number of parameters in this scoring function. If the number of parameters is not known yet, the method returns `UNKNOWN`.

  Returns:
    the number of parameters in this scoring function
  See Also:
    `ScoringFunction.UNKNOWN`

### getNumberOfRecommendedStarts

    public int getNumberOfRecommendedStarts()

  Description copied from interface: `ScoringFunction`
  This method return the number of recommended optimization starts. The standard implementation returns 1.

  Specified by:
    `getNumberOfRecommendedStarts` in interface `ScoringFunction`
  Overrides:
    `getNumberOfRecommendedStarts` in class `AbstractNormalizableScoringFunction`
  Returns:
    the number of recommended optimization starts

### setParameters

    public void setParameters(double[] params,
                              int start)

  Description copied from interface: `ScoringFunction`
  This method sets the internal parameters to the values of `params` between `start` and `start + this.getNumberOfParameters() - 1`

  Parameters:
    `params` - the parameters
    `start` - the start index

### toXML

    public StringBuffer toXML()

  Description copied from interface: `Storable`
  This method returns an XML-representation of an instance of the implementing class.

  Returns:
    the XML-representation

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getLogPriorTerm

    public double getLogPriorTerm()

  Description copied from interface: `NormalizableScoringFunction`
  This method computes a value that is proportional to

  `getESS()*Math.log( getNormalizationConstant() ) + Math.log( prior ).`

  where `prior`is the prior for the parameters of this model.

  ``
  Returns:
    `getESS()*Math.log( getNormalizationConstant() ) + Math.log( prior )`
  See Also:
    `NormalizableScoringFunction.getEss()`, `NormalizableScoringFunction.getNormalizationConstant()`

### addGradientOfLogPriorTerm

    public void addGradientOfLogPriorTerm(double[] grad,
                                          int start)
                                   throws Exception

  Description copied from interface: `NormalizableScoringFunction`
  This method computes the gradient of `getLogPriorTerm()` for each parameter of this model. The results are added to the array `grad` beginning at index `start`.

  Parameters:
    `grad` - the gradient
    `start` - the start index in the `grad` array, where the partial derivations for the parameters of this models shall be enter
  Throws:
    `Exception`
  See Also:
    `NormalizableScoringFunction.getLogPriorTerm()`

### isInitialized

    public boolean isInitialized()

  Description copied from interface: `ScoringFunction`
  This method can be used to determine whether the model is initialized. If the model is not initialize you should invoke the method `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])`.

  Returns:
    `true` if the model is initialized

### initializeFunctionRandomly

    public void initializeFunctionRandomly(boolean freeParams)
                                    throws Exception

  Description copied from interface: `ScoringFunction`
  This method initializes the scoring function randomly. It has to create the underlying structure of the scoring function.

  Parameters:
    `freeParams` - if true, the (reduced) parameterization is used
  Throws:
    `Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD